/*
 *  $Id: GUI-filesel.c,v 1.1.1.1 2001/03/22 06:40:31 davej Exp $
 *	This file is part of Powertweak Linux.
 *	(C) 2000 Dave Jones, Arjan van de Ven.
 *
 * 	Licensed under the terms of the GNU GPL License version 2.
 *
 *  Routines used to create the GTK GUI
 */

//#include <stdio.h>
//#include <stdlib.h>
#include <gtk/gtk.h>
#include <config.h>
#include <bfd.h>
#include <bucomm.h>

#include "include/macros.h"

extern void display_file (char *, char *);

static void OpenFileCallback (__unused GtkWidget *w, gpointer data)
{
	char *filename;

	filename = gtk_file_selection_get_filename(GTK_FILE_SELECTION (data));

	gtk_widget_hide (data);
	gtk_grab_remove (data);

	bfd_init();
	set_default_bfd_target();
	display_file (filename, NULL);

	gtk_widget_destroy(GTK_WIDGET(data));
}


void GetFilename ()
{
	GtkWidget *fs;

	fs = gtk_file_selection_new ("Load binary");

	gtk_signal_connect (GTK_OBJECT (fs), "destroy",
		(GtkSignalFunc) gtk_widget_destroy, GTK_OBJECT(fs)) ;

	gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION(fs)->ok_button),
		"clicked", (GtkSignalFunc) OpenFileCallback, fs);

	gtk_signal_connect_object (GTK_OBJECT
		(GTK_FILE_SELECTION(fs)->cancel_button),
		"clicked", (GtkSignalFunc) gtk_widget_destroy, (gpointer) fs);

	gtk_grab_add (fs);
	gtk_widget_show(fs);
}
