#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "GUI-input-callbacks.h"
#include "GUI-input-interface.h"

GtkWidget *entry1;
int change_row, change_col;

GtkWidget*
create_inputbox (char *inputstring)
{
  GtkWidget *inputbox;
  GtkWidget *hbox1;
  GtkWidget *vbox1;
  GtkWidget *label1;
  GtkWidget *hbox2;
  GtkWidget *OKbutton;
  GtkWidget *Cancelbutton;

  inputbox = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_name (inputbox, "inputbox");
  gtk_object_set_data (GTK_OBJECT (inputbox), "inputbox", inputbox);
  gtk_window_set_title (GTK_WINDOW (inputbox), "Input");
  gtk_window_set_position (GTK_WINDOW (inputbox), GTK_WIN_POS_MOUSE);
  gtk_window_set_policy (GTK_WINDOW (inputbox), FALSE, FALSE, FALSE);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox1, "hbox1");
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (inputbox), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_container_add (GTK_CONTAINER (inputbox), hbox1);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox1, "vbox1");
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (inputbox), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_box_pack_start (GTK_BOX (hbox1), vbox1, TRUE, TRUE, 0);

  label1 = gtk_label_new ("Change element value:");
  gtk_widget_set_name (label1, "label1");
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (inputbox), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (vbox1), label1, FALSE, FALSE, 0);

  entry1 = gtk_entry_new ();
  gtk_widget_set_name (entry1, "entry1");
  gtk_widget_ref (entry1);
  gtk_object_set_data_full (GTK_OBJECT (inputbox), "entry1", entry1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_entry_set_text (GTK_ENTRY (entry1), inputstring);
  gtk_widget_show (entry1);
  gtk_box_pack_start (GTK_BOX (vbox1), entry1, FALSE, FALSE, 0);

  hbox2 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox2, "hbox2");
  gtk_widget_ref (hbox2);
  gtk_object_set_data_full (GTK_OBJECT (inputbox), "hbox2", hbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox2, TRUE, TRUE, 0);

  OKbutton = gtk_button_new_with_label ("Okay");
  gtk_widget_set_name (OKbutton, "OKbutton");
  gtk_widget_ref (OKbutton);
  gtk_object_set_data_full (GTK_OBJECT (inputbox), "OKbutton", OKbutton,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (OKbutton);
  gtk_box_pack_start (GTK_BOX (hbox2), OKbutton, TRUE, TRUE, 50);

  Cancelbutton = gtk_button_new_with_label ("Cancel");
  gtk_widget_set_name (Cancelbutton, "Cancelbutton");
  gtk_widget_ref (Cancelbutton);
  gtk_object_set_data_full (GTK_OBJECT (inputbox), "Cancelbutton", Cancelbutton,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (Cancelbutton);
  gtk_box_pack_start (GTK_BOX (hbox2), Cancelbutton, TRUE, TRUE, 50);

  gtk_signal_connect (GTK_OBJECT (entry1), "changed",
                      GTK_SIGNAL_FUNC (on_entry1_changed),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (OKbutton), "clicked",
                      GTK_SIGNAL_FUNC (on_OKbutton_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (Cancelbutton), "clicked",
                      GTK_SIGNAL_FUNC (on_Cancelbutton_clicked),
                      NULL);

  return inputbox;
}

